## vc 1.4.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

cmake_policy(SET CMP0028 NEW) # Double colon in target name means ALIAS or IMPORTED target.
cmake_policy(SET CMP0048 NEW) # The ``project()`` command manages VERSION variables.

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
   message(FATAL_ERROR "You don't want to configure in the source directory!")
endif()

if(NOT DEFINED CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebug RelWithDebInfo MinSizeRel."
      FORCE)
endif()

# read version parts from version.h
file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/Vc/version.h _version_lines REGEX "^#define Vc_VERSION_STRING ")
string(REGEX MATCH "([0-9]+)\\.([0-9]+)\\.([0-9]+)" _version_matches "${_version_lines}")

project(Vc VERSION "${CMAKE_MATCH_1}.${CMAKE_MATCH_2}.${CMAKE_MATCH_3}" LANGUAGES C CXX)
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

set(disabled_targets)

include (VcMacros)
include (AddTargetProperty)
include (OptimizeForArchitecture)

vc_determine_compiler()

if("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "(i686|x86|AMD64|amd64)")
   set(Vc_X86 TRUE)
elseif("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "(arm|aarch32|aarch64)")
   message(WARNING "No optimized implementation of the Vc types available for ${CMAKE_SYSTEM_PROCESSOR}")
   set(Vc_ARM TRUE)
else()
   message(WARNING "No optimized implementation of the Vc types available for ${CMAKE_SYSTEM_PROCESSOR}")
endif()

option(USE_CCACHE "If enabled, ccache will be used (if it exists on the system) to speed up recompiles." OFF)
if(USE_CCACHE)
   find_program(CCACHE_COMMAND ccache)
   if(CCACHE_COMMAND)
      mark_as_advanced(CCACHE_COMMAND)
      set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_COMMAND}")
   endif()
endif()

# TODO: check that 'decltype' compiles
# TODO: check that 'constexpr' compiles
if(NOT Vc_COMPILER_IS_MSVC) # MSVC doesn't provide a switch to turn C++11 on/off AFAIK
   AddCompilerFlag("-std=c++14" CXX_RESULT _ok CXX_FLAGS CMAKE_CXX_FLAGS)
   if(NOT _ok)
      AddCompilerFlag("-std=c++1y" CXX_RESULT _ok CXX_FLAGS CMAKE_CXX_FLAGS)
      if(NOT _ok)
         AddCompilerFlag("-std=c++11" CXX_RESULT _ok CXX_FLAGS CMAKE_CXX_FLAGS)
         if(NOT _ok)
            AddCompilerFlag("-std=c++0x" CXX_RESULT _ok CXX_FLAGS CMAKE_CXX_FLAGS)
            if(NOT _ok)
               message(FATAL_ERROR "Vc 1.x requires C++11, better even C++14. It seems this is not available. If this was incorrectly determined please notify vc-devel@compeng.uni-frankfurt.de")
            endif()
         endif()
      endif()
   endif()
elseif(Vc_MSVC_VERSION LESS 180021114)
   message(FATAL_ERROR "Vc 1.x requires C++11 support. This requires at least Visual Studio 2013 with the Nov 2013 CTP.")
endif()

if(Vc_COMPILER_IS_GCC)
   if(Vc_GCC_VERSION VERSION_GREATER "5.0.0" AND Vc_GCC_VERSION VERSION_LESS "6.0.0")
      UserWarning("GCC 5 goes into an endless loop comiling example_scaling_scalar. Therefore, this target is disabled.")
      list(APPEND disabled_targets
         example_scaling_scalar
         )
   endif()
elseif(Vc_COMPILER_IS_MSVC)
   if(MSVC_VERSION LESS 1700)
      # MSVC before 2012 has a broken std::vector::resize implementation. STL + Vc code will probably not compile.
      # UserWarning in VcMacros.cmake
      list(APPEND disabled_targets
         stlcontainer_sse
         stlcontainer_avx
         )
   endif()
   # Disable warning "C++ exception specification ignored except to indicate a function is not __declspec(nothrow)"
   # MSVC emits the warning for the _UnitTest_Compare desctructor which needs the throw declaration so that it doesn't std::terminate
   AddCompilerFlag("/wd4290")
endif()

vc_set_preferred_compiler_flags(WARNING_FLAGS BUILDTYPE_FLAGS)

add_definitions(${Vc_DEFINITIONS})
add_compile_options(${Vc_COMPILE_FLAGS})

if(Vc_COMPILER_IS_INTEL)
   # per default icc is not IEEE compliant, but we need that for verification
   AddCompilerFlag("-fp-model source")
endif()

if(CMAKE_BUILD_TYPE STREQUAL "" AND NOT CMAKE_CXX_FLAGS MATCHES "-O[123]")
   message(STATUS "WARNING! It seems you are compiling without optimization. Please set CMAKE_BUILD_TYPE.")
endif(CMAKE_BUILD_TYPE STREQUAL "" AND NOT CMAKE_CXX_FLAGS MATCHES "-O[123]")

include_directories(${CMAKE_CURRENT_SOURCE_DIR}) # ${CMAKE_CURRENT_SOURCE_DIR}/include)

add_custom_target(other VERBATIM)
add_custom_target(Scalar COMMENT "build Scalar code" VERBATIM)
add_custom_target(SSE COMMENT "build SSE code" VERBATIM)
add_custom_target(AVX COMMENT "build AVX code" VERBATIM)
add_custom_target(AVX2 COMMENT "build AVX2 code" VERBATIM)

AddCompilerFlag(-ftemplate-depth=128 CXX_FLAGS CMAKE_CXX_FLAGS)

set(libvc_compile_flags "-DVc_COMPILE_LIB")
AddCompilerFlag("-fPIC" CXX_FLAGS libvc_compile_flags)

# -fstack-protector is the default of GCC, but at least Ubuntu changes the default to -fstack-protector-strong, which is crazy
AddCompilerFlag("-fstack-protector" CXX_FLAGS libvc_compile_flags)

set(_srcs src/const.cpp)
if(Vc_X86)
   list(APPEND _srcs src/cpuid.cpp src/support_x86.cpp)
   vc_compile_for_all_implementations(_srcs src/trigonometric.cpp ONLY SSE2 SSE3 SSSE3 SSE4_1 AVX SSE+XOP+FMA4 AVX+XOP+FMA4 AVX+XOP+FMA AVX+FMA AVX2+FMA+BMI2)
   vc_compile_for_all_implementations(_srcs src/sse_sorthelper.cpp ONLY SSE2 SSE4_1 AVX AVX2+FMA+BMI2)
   vc_compile_for_all_implementations(_srcs src/avx_sorthelper.cpp ONLY AVX AVX2+FMA+BMI2)
elseif(Vc_ARM)
   list(APPEND _srcs src/support_dummy.cpp)
else()
   list(APPEND _srcs src/support_dummy.cpp)
endif()
add_library(Vc STATIC ${_srcs})
set_property(TARGET Vc APPEND PROPERTY COMPILE_OPTIONS ${libvc_compile_flags})
add_target_property(Vc LABELS "other")
if(XCODE)
   # TODO: document what this does and why it has no counterpart in the non-XCODE logic
   set_target_properties(Vc PROPERTIES XCODE_ATTRIBUTE_GCC_INLINES_ARE_PRIVATE_EXTERN "NO")
   set_target_properties(Vc PROPERTIES XCODE_ATTRIBUTE_GCC_SYMBOLS_PRIVATE_EXTERN "YES")
   set_target_properties(Vc PROPERTIES XCODE_ATTRIBUTE_CLANG_CXX_LANGUAGE_STANDARD "c++0x")
   set_target_properties(Vc PROPERTIES XCODE_ATTRIBUTE_CLANG_CXX_LIBRARY "libc++")
elseif(UNIX AND Vc_COMPILER_IS_CLANG)
   # On UNIX (Linux) the standard library used by default typically is libstdc++ (GCC).
   # To get the full clang deal we rather want to build against libc++. This requires
   # additionally the libc++abi and libsupc++ libraries in all linker invokations.
   option(USE_LIBC++ "Use libc++ instead of the system default C++ standard library." OFF)
   if(USE_LIBC++)
      AddCompilerFlag(-stdlib=libc++ CXX_FLAGS CMAKE_CXX_FLAGS CXX_RESULT _use_libcxx)
      if(_use_libcxx)
         find_library(LIBC++ABI c++abi)
         mark_as_advanced(LIBC++ABI)
         if(LIBC++ABI)
            set(CMAKE_REQUIRED_LIBRARIES "${LIBC++ABI};supc++")
            CHECK_CXX_SOURCE_COMPILES("#include <stdexcept>
            #include <iostream>
            void foo() {
              std::cout << 'h' << std::flush << std::endl;
              throw std::exception();
            }
            int main() {
              try { foo(); }
              catch (int) { return 0; }
              return 1;
            }" libcxx_compiles)
            unset(CMAKE_REQUIRED_LIBRARIES)
            if(libcxx_compiles)
               link_libraries(${LIBC++ABI} supc++)
            endif()
         endif()
      endif()
   else()
      CHECK_CXX_SOURCE_COMPILES("#include <tuple>
      std::tuple<int> f() { std::tuple<int> r; return r; }
      int main() { return 0; }
      " tuple_sanity)
      if (NOT tuple_sanity)
         message(FATAL_ERROR "Clang and std::tuple brokenness detected. Please update your compiler.")
      endif()
   endif()
endif()
add_dependencies(other Vc)
target_include_directories(Vc
   PUBLIC
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}>
   $<INSTALL_INTERFACE:include>
   )

install(TARGETS Vc EXPORT VcTargets DESTINATION lib${LIB_SUFFIX})
install(DIRECTORY Vc/ DESTINATION include/Vc FILES_MATCHING REGEX "/*.(h|tcc|def)$")
install(FILES
   Vc/Allocator
   Vc/IO
   Vc/Memory
   Vc/SimdArray
   Vc/Utils
   Vc/Vc
   Vc/algorithm
   Vc/array
   Vc/iterators
   Vc/limits
   Vc/simdize
   Vc/span
   Vc/type_traits
   Vc/vector
   DESTINATION include/Vc)

# Generate and install CMake package and modules
include(CMakePackageConfigHelpers)
set(PACKAGE_INSTALL_DESTINATION
   lib${LIB_SUFFIX}/cmake/${PROJECT_NAME}
   )
install(EXPORT ${PROJECT_NAME}Targets
   NAMESPACE ${PROJECT_NAME}::
   DESTINATION ${PACKAGE_INSTALL_DESTINATION}
   EXPORT_LINK_INTERFACE_LIBRARIES
   )
write_basic_package_version_file(
   ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}ConfigVersion.cmake
   VERSION ${PROJECT_VERSION}
   COMPATIBILITY AnyNewerVersion
   )
configure_package_config_file(
   ${CMAKE_SOURCE_DIR}/cmake/${PROJECT_NAME}Config.cmake.in
   ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}Config.cmake
   INSTALL_DESTINATION ${PACKAGE_INSTALL_DESTINATION}
   PATH_VARS CMAKE_INSTALL_PREFIX
   )
install(FILES
   cmake/UserWarning.cmake
   cmake/VcMacros.cmake
   cmake/AddCompilerFlag.cmake
   cmake/CheckCCompilerFlag.cmake
   cmake/CheckCXXCompilerFlag.cmake
   cmake/OptimizeForArchitecture.cmake
   cmake/FindVc.cmake
   ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}Config.cmake
   ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}ConfigVersion.cmake
   DESTINATION ${PACKAGE_INSTALL_DESTINATION}
   )

option(BUILD_TESTING "Build the testing tree." OFF)
include (CTest)
configure_file(${CMAKE_SOURCE_DIR}/CTestCustom.cmake ${CMAKE_BINARY_DIR}/CTestCustom.cmake COPYONLY)
if(BUILD_TESTING)
   add_custom_target(build_tests ALL VERBATIM)
   add_subdirectory(tests)
endif(BUILD_TESTING)

set(BUILD_EXAMPLES FALSE CACHE BOOL "Build examples.")
if(BUILD_EXAMPLES)
   add_subdirectory(examples)
endif(BUILD_EXAMPLES)

# Hide Vc_IMPL as it is only meant for users of Vc
mark_as_advanced(Vc_IMPL)

find_program(BIN_CAT cat)
mark_as_advanced(BIN_CAT)
if(BIN_CAT)
   file(REMOVE ${CMAKE_BINARY_DIR}/help.txt)
   add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/help.txt
      COMMAND ${CMAKE_MAKE_PROGRAM} help > ${CMAKE_BINARY_DIR}/help.txt
      VERBATIM
      )
   add_custom_target(cached_help
      ${BIN_CAT} ${CMAKE_BINARY_DIR}/help.txt
      DEPENDS ${CMAKE_BINARY_DIR}/help.txt
      VERBATIM
      )
endif()

=== tests/CMakeLists.txt ===
include(AddFileDependencies)

# ICC warns about code that produces reference values. Not useful.
# warning #264: floating-point value does not fit in required floating-point type
AddCompilerFlag("-diag-disable 264" CXX_FLAGS CMAKE_CXX_FLAGS)
# warning #61: integer operation result is out of range
AddCompilerFlag("-diag-disable 61" CXX_FLAGS CMAKE_CXX_FLAGS)

add_definitions(-DCOMPILE_FOR_UNIT_TESTS "-DTESTDATA_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}/testdata/\"") # -DVC_CHECK_ALIGNMENT)
if(Vc_COMPILER_IS_MSVC)
   AddCompilerFlag("/wd4267") # Disable warning "conversion from 'size_t' to 'int', possible loss of data"
   AddCompilerFlag("/wd4723") # Disable warning "potential divide by 0" (suppress doesn't work)
   AddCompilerFlag("/wd4503") # Disable warning "decorated name length exceeded, name was truncated"
endif()

# 32-bit x86 requires SSE for fp math to produce comparable results.
AddCompilerFlag("-mfpmath=sse" CXX_FLAGS Vc_ARCHITECTURE_FLAGS CXX_RESULT _fpmath_ok)

set(Vc_SCALAR_FLAGS "${Vc_ARCHITECTURE_FLAGS};-DVc_IMPL=Scalar")
set(Vc_SSE_FLAGS    "${Vc_ARCHITECTURE_FLAGS};-DVc_IMPL=SSE")
set(Vc_AVX_FLAGS    "${Vc_ARCHITECTURE_FLAGS};-DVc_IMPL=AVX")
set(Vc_AVX2_FLAGS   "${Vc_ARCHITECTURE_FLAGS};-DVc_IMPL=AVX2")

if(USE_XOP)
   set(Vc_SSE_FLAGS  "${Vc_SSE_FLAGS}+XOP")
   set(Vc_AVX_FLAGS  "${Vc_AVX_FLAGS}+XOP")
endif()
if(USE_FMA)
   set(Vc_SSE_FLAGS  "${Vc_SSE_FLAGS}+FMA")
   set(Vc_AVX_FLAGS  "${Vc_AVX_FLAGS}+FMA")
   set(Vc_AVX2_FLAGS "${Vc_AVX2_FLAGS}+FMA")
elseif(USE_FMA4)
   set(Vc_SSE_FLAGS  "${Vc_SSE_FLAGS}+FMA4")
   set(Vc_AVX_FLAGS  "${Vc_AVX_FLAGS}+FMA4")
endif()
if(USE_BMI2)
   set(Vc_AVX2_FLAGS "${Vc_AVX2_FLAGS}+BMI2")
endif()

if(DEFINED Vc_INSIDE_ROOT)
   set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "")  # Reset the ROOT default executable destination
   set(Vc_TEST_TARGET_PREFIX "vc-")
else()
   set(Vc_TEST_TARGET_PREFIX "")
endif()

# don't warn about sanity checks:
if(Vc_COMPILER_IS_CLANG)
   # GCC does not complain about the following flags until much later. Therefore
   # the AddCompilerFlag logic doesn't work as intended.
   AddCompilerFlag(-Wno-tautological-constant-out-of-range-compare)
   AddCompilerFlag(-Wno-tautological-compare)
endif()

CHECK_CXX_SOURCE_COMPILES("#include <cxxabi.h>
int main() { return 0; }" cxx_abi_header_works)
if(cxx_abi_header_works)
   add_definitions(-DHAVE_CXX_ABI_H)
endif()

macro(vc_set_first_flag_of _result)
   set(${_result})
   foreach(_flag ${ARGN})
      AddCompilerFlag("${_flag}" CXX_FLAGS ${_result} CXX_RESULT _ok)
      if(_ok)
         break()
      endif()
   endforeach()
endmacro()

vc_set_first_flag_of(_sse2_flag "-xSSE2" "-msse2" "/arch:SSE2")
vc_set_first_flag_of(_sse4_1_flag "-xSSE4.1" "-msse4.1" "/arch:SSE2")
vc_set_first_flag_of(_avx_flag "-xAVX" "-mavx" "/arch:AVX")
vc_set_first_flag_of(_avx2_flag "-xCORE-AVX2" "-mavx2" "/arch:AVX2")
macro(vc_add_run_target _target)
   if("${CMAKE_GENERATOR}" MATCHES "Visual Studio")
      # do nothing. This just clutters the solution explorer
   else()
      add_custom_target(run_${_target}
         ${_target} -v
         DEPENDS ${_target}
         COMMENT "Execute ${_target} test"
         VERBATIM
         )
      list(APPEND _run_targets "run_${_target}")
   endif()
endmacro()

macro(vc_set_test_target_properties _target _impl _compile_flags)
   target_link_libraries(${_target} Vc)
   set_target_properties(${_target} PROPERTIES XCODE_ATTRIBUTE_CLANG_CXX_LANGUAGE_STANDARD "c++0x")
   set_target_properties(${_target} PROPERTIES XCODE_ATTRIBUTE_CLANG_CXX_LIBRARY "libc++")
   add_target_property(${_target} COMPILE_FLAGS "${_extra_flags}")
   set_property(TARGET ${_target} APPEND PROPERTY COMPILE_OPTIONS ${_compile_flags})
   add_target_property(${_target} LABELS "${_impl}")
   add_dependencies(build_tests ${_target})
   add_dependencies(${_impl} ${_target})
   add_test(${Vc_TEST_TARGET_PREFIX}${_target} "${CMAKE_CURRENT_BINARY_DIR}/${_target}")
   set_property(TEST ${Vc_TEST_TARGET_PREFIX}${_target} PROPERTY LABELS "${_impl}")
   vc_add_run_target(${_target})
endmacro()

macro(vc_add_test _name)
   set(_extra_flags)
   set(name ${_name})
   set(_state 0)
   if(Vc_X86)
      set(_targets "Scalar;SSE;AVX1;AVX2")
   else()
      set(_targets "Scalar")
   endif()
   foreach(_arg ${ARGN})
      if("${_arg}" STREQUAL "FLAGS")
         set(_state 0)
      elseif("${_arg}" STREQUAL "TARGETS")
         set(_targets)
         set(_state 1)
      elseif(_state EQUAL 0)
         set(_extra_flags "${_extra_flags} -D${_arg}")
         set(name "${name}_${_arg}")
      elseif(_state EQUAL 1)
         if("${_arg}" STREQUAL "AVX")
            list(APPEND _targets "AVX1")
         else()
            list(APPEND _targets "${_arg}")
         endif()
      endif()
   endforeach()
   string(REPLACE "=" "_" name "${name}")

   set(_run_targets)

   set(_target "${name}_scalar")
   list(FIND disabled_targets ${_target} _disabled)
   if(_disabled EQUAL -1 AND "${_targets}" MATCHES "Scalar")
      file(GLOB _extra_deps "${CMAKE_SOURCE_DIR}/Vc/scalar/*.tcc" "${CMAKE_SOURCE_DIR}/Vc/scalar/*.h" "${CMAKE_SOURCE_DIR}/Vc/common/*.h")
      add_file_dependencies(${_name}.cpp "${_extra_deps}")
      add_executable(${_target} EXCLUDE_FROM_ALL ${_name}.cpp)
      vc_set_test_target_properties(${_target} Scalar "${Vc_SCALAR_FLAGS}")
   endif()

   if(USE_SSE2 AND NOT Vc_SSE_INTRINSICS_BROKEN AND "${_targets}" MATCHES "SSE")
      set(_target "${name}_sse")
      list(FIND disabled_targets ${_target} _disabled)
      if(_disabled EQUAL -1)
         file(GLOB _extra_deps "${CMAKE_SOURCE_DIR}/Vc/sse/*.tcc" "${CMAKE_SOURCE_DIR}/Vc/sse/*.h" "${CMAKE_SOURCE_DIR}/Vc/common/*.h")
         add_file_dependencies(${_name}.cpp "${_extra_deps}")
         add_executable(${_target} EXCLUDE_FROM_ALL ${_name}.cpp)
         vc_set_test_target_properties(${_target} SSE "${Vc_SSE_FLAGS}")
      endif()
   endif()

   if(USE_AVX AND "${_targets}" MATCHES "AVX1")
      set(_target "${name}_avx")
      list(FIND disabled_targets ${_target} _disabled)
      if(_disabled EQUAL -1)
         file(GLOB _extra_deps "${CMAKE_SOURCE_DIR}/Vc/avx/*.tcc" "${CMAKE_SOURCE_DIR}/Vc/avx/*.h" "${CMAKE_SOURCE_DIR}/Vc/common/*.h")
         add_file_dependencies(${_name}.cpp "${_extra_deps}")
         add_executable(${_target} EXCLUDE_FROM_ALL ${_name}.cpp)
         vc_set_test_target_properties(${_target} AVX "${Vc_AVX_FLAGS}")
      endif()
   endif()

   if(USE_AVX2 AND "${_targets}" MATCHES "AVX2")
      set(_target "${name}_avx2")
      list(FIND disabled_targets ${_target} _disabled)
      if(_disabled EQUAL -1)
         file(GLOB _extra_deps "${CMAKE_SOURCE_DIR}/Vc/avx/*.tcc" "${CMAKE_SOURCE_DIR}/Vc/avx/*.h" "${CMAKE_SOURCE_DIR}/Vc/common/*.h")
         add_file_dependencies(${_name}.cpp "${_extra_deps}")
         add_executable(${_target} EXCLUDE_FROM_ALL ${_name}.cpp)
         vc_set_test_target_properties(${_target} AVX2 "${Vc_AVX2_FLAGS}")
      endif()
   endif()

   if(_run_targets)
      add_custom_target(run_${name}_all
         COMMENT "Execute all ${name} tests"
         VERBATIM
         )
      add_dependencies(run_${name}_all ${_run_targets})
   endif()

endmacro(vc_add_test)

vc_add_test(types)
vc_add_test(subscript)
vc_add_test(type_traits)
vc_add_test(stlcontainer)
vc_add_test(scalaraccess)
vc_add_test(memory)
vc_add_test(arithmetics)
vc_add_test(simdize)
vc_add_test(implicit_type_conversion)
vc_add_test(iterators)
vc_add_test(load)
vc_add_test(store)
vc_add_test(gather)
vc_add_test(scatter)
vc_add_test(ulp)
vc_add_test(logarithm)
vc_add_test(trigonometric)
vc_add_test(math)
vc_add_test(gh200)
vc_add_test(reductions)
vc_add_test(mask)
vc_add_test(utils)
vc_add_test(sorted)
vc_add_test(random)
vc_add_test(deinterleave)
vc_add_test(gatherinterleavedmemory)
vc_add_test(scatterinterleavedmemory)
vc_add_test(casts Vc_DEFAULT_TYPES)
if(Vc_X86)
   vc_add_test(gather Vc_USE_BSF_GATHERS TARGETS SSE AVX AVX2)
   vc_add_test(gather Vc_USE_POPCNT_BSF_GATHERS TARGETS SSE AVX AVX2)
   vc_add_test(gather Vc_USE_SET_GATHERS TARGETS SSE AVX AVX2)
   vc_add_test(scatter Vc_USE_BSF_SCATTERS TARGETS SSE AVX AVX2)
   vc_add_test(scatter Vc_USE_POPCNT_BSF_SCATTERS TARGETS SSE AVX AVX2)
   vc_add_test(logarithm Vc_LOG_ILP TARGETS SSE AVX AVX2)
   vc_add_test(logarithm Vc_LOG_ILP2 TARGETS SSE AVX AVX2)
   vc_add_test(scatterinterleavedmemory Vc_USE_MASKMOV_SCATTER TARGETS SSE AVX AVX2)
endif()
option(BUILD_EXTRA_CAST_TESTS "build all possible combinations of simd_cast tests (compiles for a very long time)" FALSE)
if(BUILD_EXTRA_CAST_TESTS)
   vc_add_test(casts Vc_EXTRA_TYPES)
   foreach(n 1 2 3 4 5 8 16 17 31)
      vc_add_test(casts Vc_FROM_N=${n})
      vc_add_test(casts Vc_TO_N=${n})
      foreach(m 1 2 3 4 5 8 16 17 31)
         vc_add_test(casts Vc_FROM_N=${m} Vc_TO_N=${n})
      endforeach()
   endforeach()
endif()
vc_add_test(simdarray)

get_property(_incdirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
set(incdirs)
foreach(_d ${_incdirs})
   list(APPEND incdirs "-I${_d}")
endforeach()

separate_arguments(_flags UNIX_COMMAND "${CMAKE_CXX_FLAGS} ${Vc_DEFINITIONS}")
list(APPEND _flags ${Vc_COMPILE_FLAGS})
set(_tmp)
foreach(_f ${_flags})
   if(_f MATCHES "^-m" OR _f MATCHES "^/arch:" OR _f MATCHES "^-x")
      # nothing
   elseif(_f MATCHES "^/[A-Za-z]")
      string(SUBSTRING "${_f}" 1 -1 _f)
      list(APPEND _tmp "-${_f}")
   else()
      list(APPEND _tmp "${_f}")
   endif()
endforeach()
set(_flags "${_tmp}")

# Test ABI on 64-bit x86: Vector/Mask arguments and return values should pass via registers.
# The 32 bit ABI only allows passing via the stack, so nothing useful to test there.
if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "(x86_64|AMD64|amd64)")
   macro(test_abi _target _impl)
      set(_test test_${_target})
      set(asmfile "${_target}.i")
      add_custom_command(OUTPUT ${asmfile}
         COMMAND ${CMAKE_CXX_COMPILER}
         ${incdirs} ${_flags} -O1 -DVc_IMPL=${_impl} ${ARGN} -S -o ${asmfile}
         ${CMAKE_CURRENT_SOURCE_DIR}/abi.cpp
         DEPENDS abi.cpp ${CMAKE_SOURCE_DIR}/Vc/*/*.h ${CMAKE_SOURCE_DIR}/Vc/*/*.tcc
         WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
         COMMENT "Build ABI test: ${asmfile}"
         VERBATIM
         )
      add_custom_target(${_target} DEPENDS ${asmfile})
      add_target_property(${_target} LABELS "${_impl}")
      add_dependencies(${_impl} ${_target})
      add_dependencies(build_tests ${_target})

      add_test(NAME ${_test}
         WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
         COMMAND ${CMAKE_COMMAND} -DASM=${asmfile} -DIMPL=${_impl}
         -DCOMPILER_IS_CLANG=${Vc_COMPILER_IS_CLANG} -DSYSTEM_NAME=${CMAKE_SYSTEM_NAME}
         -P ${CMAKE_CURRENT_SOURCE_DIR}/abi.cmake
         )
      set_property(TEST ${_test} PROPERTY LABELS "${_impl}")
      add_custom_target(run_${_target}
         ${CMAKE_COMMAND} -DASM=${asmfile} -DIMPL=${_impl}
         -DCOMPILER_IS_CLANG=${Vc_COMPILER_IS_CLANG} -DSYSTEM_NAME=${CMAKE_SYSTEM_NAME}
         -P ${CMAKE_CURRENT_SOURCE_DIR}/abi.cmake
         WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
         DEPENDS ${asmfile}
         COMMENT "Execute ${_target} test"
         VERBATIM
         )
   endmacro()

   if("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "[x3-7]86")
      test_abi(abi_SSE     SSE  ${_sse2_flag})
      test_abi(abi_SSE_AVX SSE  ${_avx_flag})
      if(NOT Vc_AVX_INTRINSICS_BROKEN)
         test_abi(abi_AVX     AVX  ${_avx_flag})
         test_abi(abi_AVX2    AVX2 ${_avx2_flag})
      endif()
   endif()
endif()

if(Vc_X86 AND USE_SSE2 AND NOT Vc_SSE_INTRINSICS_BROKEN)
   list(FIND disabled_targets sse_blend _disabled)
   if(_disabled EQUAL -1)
      add_executable(sse2_blend EXCLUDE_FROM_ALL sse_blend.cpp)
      add_target_property(sse2_blend COMPILE_DEFINITIONS "Vc_IMPL=SSE2")
      set_property(TARGET sse2_blend APPEND PROPERTY COMPILE_OPTIONS "${_sse2_flag}")
      add_target_property(sse2_blend LABELS "SSE")
      add_dependencies(build_tests sse2_blend)
      add_dependencies(SSE sse2_blend)

=== examples/mandelbrot/CMakeLists.txt ===
if(QT4_FOUND AND QT4_USABLE)
   include(${QT_USE_FILE})
   include_directories(${CMAKE_CURRENT_BINARY_DIR})
   qt4_generate_moc(main.h moc_main.cpp)
   qt4_generate_moc(mandel.h moc_mandel.cpp)

   set(SOURCES main.cpp ${CMAKE_CURRENT_BINARY_DIR}/moc_main.cpp mandel.cpp
      ${CMAKE_CURRENT_BINARY_DIR}/moc_mandel.cpp)

   build_example(mandelbrot ${SOURCES} LIBS ${QT_LIBRARIES})
endif()

=== debian/changelog ===
vc (1.4.2-2) unstable; urgency=medium

  * Upload to unstable

 -- Stephan Lachnit <stephanlachnit@debian.org>  Wed, 13 Oct 2021 14:08:56 +0200

vc (1.4.2-1) experimental; urgency=medium

  * New upstream version 1.4.2

 -- Stephan Lachnit <stephanlachnit@debian.org>  Thu, 24 Jun 2021 17:34:35 +0200

vc (1.4.1-1) experimental; urgency=medium

  [ Simon Quigley ]
  * New upstream release.
  * Fix the watch file to correctly download new releases.
  * Remove unneeded i386 patch.

  [ Stephan Lachnit ]
  * Bump Standards-version to 4.5.1, no changes needed.
  * Update debhelper-compat to 13, no changes needed.
  * Update maintainer.

 -- Stephan Lachnit <stephanlachnit@debian.org>  Sat, 15 May 2021 14:22:30 +0200

=== debian/control ===
Source: vc
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Stephan Lachnit <stephanlachnit@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
Rules-Requires-Root: no
Standards-Version: 4.6.0.1
Homepage: https://github.com/VcDevel/Vc
Vcs-Browser: https://salsa.debian.org/science-team/vc
Vcs-Git: https://salsa.debian.org/science-team/vc.git

Package: vc-dev
Section: libdevel
Architecture: any-amd64 any-arm any-arm64 any-i386
Depends:
 ${misc:Depends},
Description: C++ types for explicitly data-parallel programming
 Vc is a free software library to ease explicit vectorization of C++
 code. It has an intuitive API and provides portability between
 different compilers and compiler versions as well as portability
 between different vector instruction sets. Thus an application
 written with Vc can be compiled for:
  - AVX and AVX2
  - SSE2 up to SSE4.2 or SSE4a
  - Scalar
  - AVX-512 (in development)
  - NEON (in development)
  - NVIDIA GPUs / CUDA (in development)

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DTARGET_ARCHITECTURE=none

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/Vc-?(\d\S+)\.tar\.gz/vc_$1\.orig\.tar\.gz/ \
    https://github.com/VcDevel/Vc/releases .*/Vc-?(\d\S+)\.tar\.gz

## vc 1.4.3

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -68,10 +68,10 @@
    endforeach()
 endmacro()
 
-vc_set_first_flag_of(_sse2_flag "-xSSE2" "-msse2" "/arch:SSE2")
-vc_set_first_flag_of(_sse4_1_flag "-xSSE4.1" "-msse4.1" "/arch:SSE2")
-vc_set_first_flag_of(_avx_flag "-xAVX" "-mavx" "/arch:AVX")
-vc_set_first_flag_of(_avx2_flag "-xCORE-AVX2" "-mavx2" "/arch:AVX2")
+vc_set_first_flag_of(_sse2_flag "-msse2")
+vc_set_first_flag_of(_sse4_1_flag "-msse4.1")
+vc_set_first_flag_of(_avx_flag "-mavx" "/arch:AVX")
+vc_set_first_flag_of(_avx2_flag "-march=core-avx2" "-mavx2 -mfma -mbmi2" "/arch:AVX2")
 macro(vc_add_run_target _target)
    if("${CMAKE_GENERATOR}" MATCHES "Visual Studio")
       # do nothing. This just clutters the solution explorer
@@ -133,7 +133,7 @@
    set(_target "${name}_scalar")
    list(FIND disabled_targets ${_target} _disabled)
    if(_disabled EQUAL -1 AND "${_targets}" MATCHES "Scalar")
-      file(GLOB _extra_deps "${CMAKE_SOURCE_DIR}/Vc/scalar/*.tcc" "${CMAKE_SOURCE_DIR}/Vc/scalar/*.h" "${CMAKE_SOURCE_DIR}/Vc/common/*.h")
+      file(GLOB _extra_deps "${PROJECT_SOURCE_DIR}/Vc/scalar/*.tcc" "${PROJECT_SOURCE_DIR}/Vc/scalar/*.h" "${PROJECT_SOURCE_DIR}/Vc/common/*.h")
       add_file_dependencies(${_name}.cpp "${_extra_deps}")
       add_executable(${_target} EXCLUDE_FROM_ALL ${_name}.cpp)
       vc_set_test_target_properties(${_target} Scalar "${Vc_SCALAR_FLAGS}")
@@ -143,7 +143,7 @@
       set(_target "${name}_sse")
       list(FIND disabled_targets ${_target} _disabled)
       if(_disabled EQUAL -1)
-         file(GLOB _extra_deps "${CMAKE_SOURCE_DIR}/Vc/sse/*.tcc" "${CMAKE_SOURCE_DIR}/Vc/sse/*.h" "${CMAKE_SOURCE_DIR}/Vc/common/*.h")
+         file(GLOB _extra_deps "${PROJECT_SOURCE_DIR}/Vc/sse/*.tcc" "${PROJECT_SOURCE_DIR}/Vc/sse/*.h" "${PROJECT_SOURCE_DIR}/Vc/common/*.h")
          add_file_dependencies(${_name}.cpp "${_extra_deps}")
          add_executable(${_target} EXCLUDE_FROM_ALL ${_name}.cpp)
          vc_set_test_target_properties(${_target} SSE "${Vc_SSE_FLAGS}")
@@ -154,7 +154,7 @@
       set(_target "${name}_avx")
       list(FIND disabled_targets ${_target} _disabled)
       if(_disabled EQUAL -1)
-         file(GLOB _extra_deps "${CMAKE_SOURCE_DIR}/Vc/avx/*.tcc" "${CMAKE_SOURCE_DIR}/Vc/avx/*.h" "${CMAKE_SOURCE_DIR}/Vc/common/*.h")
+         file(GLOB _extra_deps "${PROJECT_SOURCE_DIR}/Vc/avx/*.tcc" "${PROJECT_SOURCE_DIR}/Vc/avx/*.h" "${PROJECT_SOURCE_DIR}/Vc/common/*.h")
          add_file_dependencies(${_name}.cpp "${_extra_deps}")
          add_executable(${_target} EXCLUDE_FROM_ALL ${_name}.cpp)
          vc_set_test_target_properties(${_target} AVX "${Vc_AVX_FLAGS}")
@@ -165,7 +165,7 @@
       set(_target "${name}_avx2")
       list(FIND disabled_targets ${_target} _disabled)
       if(_disabled EQUAL -1)
-         file(GLOB _extra_deps "${CMAKE_SOURCE_DIR}/Vc/avx/*.tcc" "${CMAKE_SOURCE_DIR}/Vc/avx/*.h" "${CMAKE_SOURCE_DIR}/Vc/common/*.h")
+         file(GLOB _extra_deps "${PROJECT_SOURCE_DIR}/Vc/avx/*.tcc" "${PROJECT_SOURCE_DIR}/Vc/avx/*.h" "${PROJECT_SOURCE_DIR}/Vc/common/*.h")
          add_file_dependencies(${_name}.cpp "${_extra_deps}")
          add_executable(${_target} EXCLUDE_FROM_ALL ${_name}.cpp)
          vc_set_test_target_properties(${_target} AVX2 "${Vc_AVX2_FLAGS}")
@@ -264,7 +264,7 @@
          COMMAND ${CMAKE_CXX_COMPILER}
          ${incdirs} ${_flags} -O1 -DVc_IMPL=${_impl} ${ARGN} -S -o ${asmfile}
          ${CMAKE_CURRENT_SOURCE_DIR}/abi.cpp
-         DEPENDS abi.cpp ${CMAKE_SOURCE_DIR}/Vc/*/*.h ${CMAKE_SOURCE_DIR}/Vc/*/*.tcc
+         DEPENDS abi.cpp ${PROJECT_SOURCE_DIR}/Vc/*/*.h ${PROJECT_SOURCE_DIR}/Vc/*/*.tcc
          WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
          COMMENT "Build ABI test: ${asmfile}"
          VERBATIM

=== examples/finitediff/CMakeLists.txt ===
build_example(finitediff main.cpp DISABLE Scalar)

=== examples/scaling/CMakeLists.txt ===
build_example(scaling main.cpp)

=== examples/simdize/CMakeLists.txt ===
build_example(simdize main.cpp)

=== debian/changelog ===
vc (1.4.3-1) unstable; urgency=medium

  * New upstream version 1.4.3

 -- Stephan Lachnit <stephanlachnit@debian.org>  Fri, 27 May 2022 10:11:53 +0200

vc (1.4.2-3) unstable; urgency=medium

  * Add x86-64 feature levels

 -- Stephan Lachnit <stephanlachnit@debian.org>  Wed, 06 Apr 2022 16:16:21 +0200

=== debian/control ===
--- 
+++ 
@@ -26,6 +26,3 @@
   - AVX and AVX2
   - SSE2 up to SSE4.2 or SSE4a
   - Scalar
-  - AVX-512 (in development)
-  - NEON (in development)
-  - NVIDIA GPUs / CUDA (in development)

=== debian/watch ===
version=4
https://github.com/VcDevel/Vc/releases (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## vc 1.4.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 cmake_policy(SET CMP0028 NEW) # Double colon in target name means ALIAS or IMPORTED target.
 cmake_policy(SET CMP0048 NEW) # The ``project()`` command manages VERSION variables.
 
-if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
+if(PROJECT_SOURCE_DIR STREQUAL PROJECT_BINARY_DIR)
    message(FATAL_ERROR "You don't want to configure in the source directory!")
 endif()
 
@@ -18,7 +18,7 @@
 string(REGEX MATCH "([0-9]+)\\.([0-9]+)\\.([0-9]+)" _version_matches "${_version_lines}")
 
 project(Vc VERSION "${CMAKE_MATCH_1}.${CMAKE_MATCH_2}.${CMAKE_MATCH_3}" LANGUAGES C CXX)
-set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
+list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")
 
 set(disabled_targets)
 
@@ -46,9 +46,7 @@
    endif()
 endif()
 
-# TODO: check that 'decltype' compiles
-# TODO: check that 'constexpr' compiles
-if(NOT Vc_COMPILER_IS_MSVC) # MSVC doesn't provide a switch to turn C++11 on/off AFAIK
+if(NOT Vc_COMPILER_IS_MSVC)
    AddCompilerFlag("-std=c++14" CXX_RESULT _ok CXX_FLAGS CMAKE_CXX_FLAGS)
    if(NOT _ok)
       AddCompilerFlag("-std=c++1y" CXX_RESULT _ok CXX_FLAGS CMAKE_CXX_FLAGS)
@@ -62,8 +60,16 @@
          endif()
       endif()
    endif()
-elseif(Vc_MSVC_VERSION LESS 180021114)
-   message(FATAL_ERROR "Vc 1.x requires C++11 support. This requires at least Visual Studio 2013 with the Nov 2013 CTP.")
+elseif(MSVC_VERSION LESS 1920)
+   message(FATAL_ERROR "Vc 1.x requires at least Visual Studio 2019.")
+   AddCompilerFlag("/std:c++14" CXX_RESULT _ok CXX_FLAGS CMAKE_CXX_FLAGS)
+endif()
+
+if(MSVC AND (NOT DEFINED Vc_USE_MSVC_SSA_OPTIMIZER_DESPITE_BUGGY_EXP OR NOT Vc_USE_MSVC_SSA_OPTIMIZER_DESPITE_BUGGY_EXP))
+   # bug report: https://developercommunity.visualstudio.com/t/AVX-codegen-bug-on-Vc-with-MSVC-2019/1470844#T-N1521672
+   message(STATUS "WARNING! MSVC starting with 19.20 uses a new optimizer that has a bug causing Vc::exp() to return slighly wrong results.\
+ You can set Vc_USE_MSVC_SSA_OPTIMIZER_DESPITE_BUGGY_EXP=ON to still use the new optimizer on the affected MSVC versions.")
+   AddCompilerFlag("/d2SSAOptimizer-" CXX_RESULT _ok CXX_FLAGS CMAKE_CXX_FLAGS)
 endif()
 
 if(Vc_COMPILER_IS_GCC)
@@ -74,14 +80,6 @@
          )
    endif()
 elseif(Vc_COMPILER_IS_MSVC)
-   if(MSVC_VERSION LESS 1700)
-      # MSVC before 2012 has a broken std::vector::resize implementation. STL + Vc code will probably not compile.
-      # UserWarning in VcMacros.cmake
-      list(APPEND disabled_targets
-         stlcontainer_sse
-         stlcontainer_avx
-         )
-   endif()
    # Disable warning "C++ exception specification ignored except to indicate a function is not __declspec(nothrow)"
    # MSVC emits the warning for the _UnitTest_Compare desctructor which needs the throw declaration so that it doesn't std::terminate
    AddCompilerFlag("/wd4290")
@@ -120,7 +118,13 @@
 set(_srcs src/const.cpp)
 if(Vc_X86)
    list(APPEND _srcs src/cpuid.cpp src/support_x86.cpp)
-   vc_compile_for_all_implementations(_srcs src/trigonometric.cpp ONLY SSE2 SSE3 SSSE3 SSE4_1 AVX SSE+XOP+FMA4 AVX+XOP+FMA4 AVX+XOP+FMA AVX+FMA AVX2+FMA+BMI2)
+   vc_compile_for_all_implementations(_srcs src/trigonometric.cpp ONLY SSE2 SSE3 SSSE3 SSE4_1 AVX AVX+FMA AVX2+FMA+BMI2)
+   if(NOT Vc_XOP_INTRINSICS_BROKEN)
+     vc_compile_for_all_implementations(_srcs src/trigonometric.cpp ONLY AVX+XOP+FMA)
+     if(NOT Vc_FMA4_INTRINSICS_BROKEN)
+       vc_compile_for_all_implementations(_srcs src/trigonometric.cpp ONLY SSE+XOP+FMA4 AVX+XOP+FMA4)
+     endif()
+   endif()
    vc_compile_for_all_implementations(_srcs src/sse_sorthelper.cpp ONLY SSE2 SSE4_1 AVX AVX2+FMA+BMI2)
    vc_compile_for_all_implementations(_srcs src/avx_sorthelper.cpp ONLY AVX AVX2+FMA+BMI2)
 elseif(Vc_ARM)
@@ -183,66 +187,69 @@
    $<INSTALL_INTERFACE:include>
    )
 
-install(TARGETS Vc EXPORT VcTargets DESTINATION lib${LIB_SUFFIX})
-install(DIRECTORY Vc/ DESTINATION include/Vc FILES_MATCHING REGEX "/*.(h|tcc|def)$")
-install(FILES
-   Vc/Allocator
-   Vc/IO
-   Vc/Memory
-   Vc/SimdArray
-   Vc/Utils
-   Vc/Vc
-   Vc/algorithm
-   Vc/array
-   Vc/iterators
-   Vc/limits
-   Vc/simdize
-   Vc/span
-   Vc/type_traits
-   Vc/vector
-   DESTINATION include/Vc)
-
-# Generate and install CMake package and modules
-include(CMakePackageConfigHelpers)
-set(PACKAGE_INSTALL_DESTINATION
-   lib${LIB_SUFFIX}/cmake/${PROJECT_NAME}
-   )
-install(EXPORT ${PROJECT_NAME}Targets
-   NAMESPACE ${PROJECT_NAME}::
-   DESTINATION ${PACKAGE_INSTALL_DESTINATION}
-   EXPORT_LINK_INTERFACE_LIBRARIES
-   )
-write_basic_package_version_file(
-   ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}ConfigVersion.cmake
-   VERSION ${PROJECT_VERSION}
-   COMPATIBILITY AnyNewerVersion
-   )
-configure_package_config_file(
-   ${CMAKE_SOURCE_DIR}/cmake/${PROJECT_NAME}Config.cmake.in
-   ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}Config.cmake
-   INSTALL_DESTINATION ${PACKAGE_INSTALL_DESTINATION}
-   PATH_VARS CMAKE_INSTALL_PREFIX
-   )
-install(FILES
-   cmake/UserWarning.cmake
-   cmake/VcMacros.cmake
-   cmake/AddCompilerFlag.cmake
-   cmake/CheckCCompilerFlag.cmake
-   cmake/CheckCXXCompilerFlag.cmake
-   cmake/OptimizeForArchitecture.cmake
-   cmake/FindVc.cmake
-   ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}Config.cmake
-   ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}ConfigVersion.cmake
-   DESTINATION ${PACKAGE_INSTALL_DESTINATION}
-   )
+option(Vc_ENABLE_INSTALL "Whether to install the library." ON)
+if (Vc_ENABLE_INSTALL)
+   install(TARGETS Vc EXPORT VcTargets DESTINATION lib${LIB_SUFFIX})
+   install(DIRECTORY Vc/ DESTINATION include/Vc FILES_MATCHING REGEX "/*.(h|tcc|def)$")
+   install(FILES
+      Vc/Allocator
+      Vc/IO
+      Vc/Memory
+      Vc/SimdArray
+      Vc/Utils
+      Vc/Vc
+      Vc/algorithm
+      Vc/array
+      Vc/iterators
+      Vc/limits
+      Vc/simdize
+      Vc/span
+      Vc/type_traits
+      Vc/vector
+      DESTINATION include/Vc)
+
+   # Generate and install CMake package and modules
+   include(CMakePackageConfigHelpers)
+   set(PACKAGE_INSTALL_DESTINATION
+      lib${LIB_SUFFIX}/cmake/${PROJECT_NAME}
+      )
+   install(EXPORT ${PROJECT_NAME}Targets
+      NAMESPACE ${PROJECT_NAME}::
+      DESTINATION ${PACKAGE_INSTALL_DESTINATION}
+      EXPORT_LINK_INTERFACE_LIBRARIES
+      )
+   write_basic_package_version_file(
+      ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}ConfigVersion.cmake
+      VERSION ${PROJECT_VERSION}
+      COMPATIBILITY AnyNewerVersion
+      )
+   configure_package_config_file(
+      ${PROJECT_SOURCE_DIR}/cmake/${PROJECT_NAME}Config.cmake.in
+      ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}Config.cmake
+      INSTALL_DESTINATION ${PACKAGE_INSTALL_DESTINATION}
+      PATH_VARS CMAKE_INSTALL_PREFIX
+      )
+   install(FILES
+      cmake/UserWarning.cmake
+      cmake/VcMacros.cmake
+      cmake/AddCompilerFlag.cmake
+      cmake/CheckCCompilerFlag.cmake
+      cmake/CheckCXXCompilerFlag.cmake
+      cmake/OptimizeForArchitecture.cmake
+      cmake/FindVc.cmake
+      ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}Config.cmake
+      ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}ConfigVersion.cmake
+      DESTINATION ${PACKAGE_INSTALL_DESTINATION}
+      )
+endif()
 
 option(BUILD_TESTING "Build the testing tree." OFF)
 include (CTest)
-configure_file(${CMAKE_SOURCE_DIR}/CTestCustom.cmake ${CMAKE_BINARY_DIR}/CTestCustom.cmake COPYONLY)
+configure_file(${PROJECT_SOURCE_DIR}/CTestCustom.cmake ${PROJECT_BINARY_DIR}/CTestCustom.cmake COPYONLY)
 if(BUILD_TESTING)
    add_custom_target(build_tests ALL VERBATIM)
    add_subdirectory(tests)
-endif(BUILD_TESTING)
+endif()
 
 set(BUILD_EXAMPLES FALSE CACHE BOOL "Build examples.")
 if(BUILD_EXAMPLES)
@@ -255,14 +262,14 @@
 find_program(BIN_CAT cat)
 mark_as_advanced(BIN_CAT)
 if(BIN_CAT)
-   file(REMOVE ${CMAKE_BINARY_DIR}/help.txt)
-   add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/help.txt
-      COMMAND ${CMAKE_MAKE_PROGRAM} help > ${CMAKE_BINARY_DIR}/help.txt
+   file(REMOVE ${PROJECT_BINARY_DIR}/help.txt)
+   add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/help.txt
+      COMMAND ${CMAKE_MAKE_PROGRAM} help > ${PROJECT_BINARY_DIR}/help.txt
       VERBATIM
       )
    add_custom_target(cached_help
-      ${BIN_CAT} ${CMAKE_BINARY_DIR}/help.txt
-      DEPENDS ${CMAKE_BINARY_DIR}/help.txt
+      ${BIN_CAT} ${PROJECT_BINARY_DIR}/help.txt
+      DEPENDS ${PROJECT_BINARY_DIR}/help.txt
       VERBATIM
       )
 endif()

=== Makefile ===
CXX ?= c++
build_dir := $(shell which $(CXX))
tmp := "case $$(readlink -f $(build_dir)) in *icecc) which $${ICECC_CXX:-g++};; *) echo $(build_dir);; esac"
build_dir := $(shell sh -c $(tmp))
build_dir := $(realpath $(build_dir))
build_dir := build-$(subst /,-,$(build_dir:/%=%)$(CXXFLAGS))

all:
%:: $(build_dir)/CMakeCache.txt
	$(MAKE) --no-print-directory -C "$(build_dir)" $(MAKECMDGOALS)

$(build_dir)/CMakeCache.txt:
	@test -n "$(build_dir)"
	@mkdir -p "$(build_dir)"
	@test -e "$(build_dir)/CMakeCache.txt" || cmake -H. -B"$(build_dir)"

print_build_dir:
	@echo "$(PWD)/$(build_dir)"

clean_builddir:
	rm -rf "$(build_dir)"

# the following rule works around %:: grabbing the Makefile rule and thus stops it from running every time
Makefile:
	@true

.PHONY: print_build_dir clean_builddir

=== examples/linear_find/CMakeLists.txt ===
build_example(linear_find main.cpp)

=== debian/changelog ===
vc (1.4.4-1) unstable; urgency=medium

  * New upstream version 1.4.4

 -- Stephan Lachnit <stephanlachnit@debian.org>  Thu, 26 Oct 2023 18:43:05 +0200

vc (1.4.3-2) unstable; urgency=medium

  * Update standards version to 4.6.1, no changes needed
  * Fix watch file due to GitHub changes

 -- Stephan Lachnit <stephanlachnit@debian.org>  Wed, 09 Nov 2022 22:14:18 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  debhelper-compat (= 13),
  cmake,
 Rules-Requires-Root: no
-Standards-Version: 4.6.0.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/VcDevel/Vc
 Vcs-Browser: https://salsa.debian.org/science-team/vc
 Vcs-Git: https://salsa.debian.org/science-team/vc.git

=== debian/watch ===
version=4
opts="searchmode=plain,filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%" \
https://api.github.com/repos/VcDevel/Vc/releases?per_page=100 \
https://api.github.com/repos/VcDevel/Vc/tarball/v?@ANY_VERSION@

## vc 1.4.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,4 @@
-cmake_minimum_required(VERSION 3.0)
-
-cmake_policy(SET CMP0028 NEW) # Double colon in target name means ALIAS or IMPORTED target.
-cmake_policy(SET CMP0048 NEW) # The ``project()`` command manages VERSION variables.
+cmake_minimum_required(VERSION 3.5)
 
 if(PROJECT_SOURCE_DIR STREQUAL PROJECT_BINARY_DIR)
    message(FATAL_ERROR "You don't want to configure in the source directory!")

=== examples/CMakeLists.txt ===
find_package(Qt4)
set(SAFE_CMAKE_REQUIRED_INCLUDES "${CMAKE_REQUIRED_INCLUDES}")
set(SAFE_CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES}")
set(CMAKE_REQUIRED_INCLUDES "${QT_INCLUDES}")
set(CMAKE_REQUIRED_LIBRARIES "${QT_QTCORE_LIBRARY}")
CHECK_CXX_SOURCE_COMPILES("#include <QObject>
int main() { QObject o; return 0;}" QT4_USABLE)
mark_as_advanced(QT4_USABLE)
set(CMAKE_REQUIRED_INCLUDES "${SAFE_CMAKE_REQUIRED_INCLUDES}")
set(CMAKE_REQUIRED_LIBRARIES "${SAFE_CMAKE_REQUIRED_LIBRARIES}")

add_custom_target(Examples COMMENT "build all examples" VERBATIM)

AddCompilerFlag(-ftemplate-depth=1024 CXX_FLAGS CMAKE_CXX_FLAGS MIC_CXX_FLAGS CMAKE_MIC_CXX_FLAGS)

macro(vc_add_run_target _target)
   if("${_target}" MATCHES "_mic$")
      if(MIC_NATIVELOAD)
         get_target_property(_exe "${_target}" OUTPUT_NAME)
         add_custom_target(run_${_target}
            ${MIC_NATIVELOAD} "${_exe}"
            DEPENDS ${_target}
            COMMENT "Execute ${_target} example"
            VERBATIM
            )
      endif()
   else()
      add_custom_target(run_${_target}
         ${_target}
         DEPENDS ${_target}
         COMMENT "Execute ${_target} example"
         VERBATIM
         )
   endif()
endmacro()

macro(_build_one_example_target _name _impl)
   set(_target "example_${_name}_${_impl}")
   string(TOLOWER "${_target}" _target)
   list(FIND _disabled_impl "${_impl}" _index1)
   list(FIND disabled_targets "${_target}" _index2)
   if(_index1 EQUAL -1 AND USE_${_impl} AND _index2 EQUAL -1)
      add_executable(${_target} ${ARGN})
      add_target_property(${_target} COMPILE_DEFINITIONS "Vc_IMPL=${_impl}")
      set_property(TARGET ${_target} APPEND PROPERTY COMPILE_OPTIONS ${Vc_ARCHITECTURE_FLAGS})
      add_target_property(${_target} LABELS "${_impl}")
      add_dependencies(${_impl} ${_target})
      add_dependencies(Examples ${_target})
      target_link_libraries(${_target} Vc ${_LIBS})
      vc_add_run_target(${_target})
   endif()
endmacro()

function(build_example name)
   set(_SRCS)
   set(_LIBS)
   set(_disabled_impl)
   set(_state 1)
   set(USE_Scalar TRUE)
   set(USE_SSE ${USE_SSE2})
   foreach(ARG ${ARGN})
      if(ARG STREQUAL "LIBS")
         set(_state 2)
      elseif(ARG STREQUAL "DISABLE")
         set(_state 3)
      elseif(_state EQUAL 1)
         set(_SRCS ${_SRCS} ${ARG})
      elseif(_state EQUAL 2)
         set(_LIBS ${_LIBS} ${ARG})
      elseif(_state EQUAL 3)
         list(APPEND _disabled_impl ${ARG})
      endif()
   endforeach()

   _build_one_example_target("${name}" Scalar ${_SRCS})
   _build_one_example_target("${name}" SSE ${_SRCS})
   _build_one_example_target("${name}" AVX ${_SRCS})
   _build_one_example_target("${name}" AVX2 ${_SRCS})

   set(_target "example_${name}_mic")
   list(FIND _disabled_impl "MIC" _index1)
   list(FIND disabled_targets "${_target}" _index2)
   if(MIC_NATIVE_FOUND AND "${_LIBS}" STREQUAL "" AND _index1 EQUAL -1 AND _index2 EQUAL -1)
      mic_add_executable(${_target}
         SOURCES ${_SRCS}
         LINK_LIBRARIES Vc_MIC
         )
      add_target_property(${_target} LABELS "MIC")
      add_dependencies(MIC ${_target})
      vc_add_run_target(${_target})
   endif()
endfunction(build_example)

file(GLOB examples RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}/*/CMakeLists.txt")
foreach(example ${examples})
   string(REPLACE "/CMakeLists.txt" "" example "${example}")
   list(FIND disabled_targets "example_${example}" _disabled)
   if(_disabled EQUAL -1)
      add_subdirectory(${example})
   endif()
endforeach()

=== examples/polarcoord/CMakeLists.txt ===
build_example(polarcoord main.cpp)

=== debian/changelog ===
vc (1.4.5-1) unstable; urgency=medium

  * New upstream version 1.4.5
  * Update standards version to 4.7.0, no changes needed

 -- Stephan Lachnit <stephanlachnit@debian.org>  Thu, 01 Aug 2024 09:04:02 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  debhelper-compat (= 13),
  cmake,
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/VcDevel/Vc
 Vcs-Browser: https://salsa.debian.org/science-team/vc
 Vcs-Git: https://salsa.debian.org/science-team/vc.git

=== debian/rules ===
#!/usr/bin/make -f

# Use SSE2 only on amd64
ifeq (,$(filter $(DEB_TARGET_ARCH),amd64))
	TARGET_ARCHITECTURE=none
else
	TARGET_ARCHITECTURE=x86-64
endif

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DTARGET_ARCHITECTURE=$(TARGET_ARCHITECTURE)
